<?php
/*
Plugin Name: Lock Site
Description: Locks the entire site and only allows access with a password
Author: wpprocode
Author URI: https://wpprocode.cz
*/

// Add the lock function to the wp action
add_action( 'wp', 'locksite_lock' );

// Define the lock function
function locksite_lock() {
  // Check if the user is logged in or the password is already set
  if ( ! is_user_logged_in() && ! isset( $_COOKIE['locksite_password'] ) ) {
    // Display the password form
    locksite_display_form();
    // Stop processing the request
    exit;
  }
}

// Define the function to display the password form
function locksite_display_form() {
  echo '
    <div style="display:flex;justify-content:center;align-items:center;height:100vh;">
      <form method="post" style="display:flex;flex-direction:column;justify-content:center;align-items:center;border:1px solid #ddd;padding:20px;border-radius:5px;background-color:#f5f5f5;">
        <p style="font-size:24px;margin-bottom:20px;text-align:center;">This site is password protected. Please enter the password:</p>
        <input type="password" name="locksite_password" style="padding:10px;margin-bottom:20px;font-size:18px;width:300px;border:1px solid #ddd;border-radius:5px;">
        <button type="submit" style="padding:10px 20px;font-size:18px;background-color:#4CAF50;color:#fff;border:none;border-radius:4px;">Submit</button>
      </form>
    </div>
  ';
}

// Add the unlock function to the init action
add_action( 'init', 'locksite_unlock' );

// Define the unlock function
function locksite_unlock() {
  // Check if the password form has been submitted
  if ( isset( $_POST['locksite_password'] ) ) {
    // Check if the password is correct
    if ( $_POST['locksite_password'] === 'Heslo2023' ) {
      // Set a cookie to remember the password
      setcookie( 'locksite_password', 'Heslo2023', time() + 31536000, '/' );
    }
    // Reload the page to unlock the site
    header( 'Location: ' . $_SERVER['REQUEST_URI'] );
    exit;
  }
}
